// ListColumnPickerDlg.cpp : implementation file
//

#include "stdafx.h"
#include "TPMSDataViewer.h"
#include "ListColumnPickerDlg.h"


// CListColumnPickerDlg dialog

IMPLEMENT_DYNAMIC(CListColumnPickerDlg, CScrollDialog)

CListColumnPickerDlg::CListColumnPickerDlg(CWnd* pParent, CListCtrl_Column_Picker* listCtrl)
	: CScrollDialog(CListColumnPickerDlg::IDD, pParent)
{
	m_pListCtrl = listCtrl;
// wooil insert - start
	CScrollDialog::m_rcOrg.SetRectEmpty();
	CScrollDialog::m_nHscrollPos = 0;
	CScrollDialog::m_nVscrollPos = 0;
	CScrollDialog::m_nHscrollMax = m_nVscrollMax = 0;
	CScrollDialog::m_nHorzInc = m_nVertInc = 0;
// wooil insert - end
}

CListColumnPickerDlg::~CListColumnPickerDlg()
{
}

void CListColumnPickerDlg::DoDataExchange(CDataExchange* pDX)
{
	CDialogEx::DoDataExchange(pDX);
}


//BEGIN_MESSAGE_MAP(CListColumnPickerDlg, CDialogEx)
//	ON_WM_DESTROY()
//END_MESSAGE_MAP()

BEGIN_MESSAGE_MAP(CListColumnPickerDlg, CScrollDialog)
	ON_WM_DESTROY()
END_MESSAGE_MAP()

// CListColumnPickerDlg message handlers

BOOL CListColumnPickerDlg::OnInitDialog()
{
	CRect rect;
	
	CDialogBase::OnInitDialog();
// wooil insert - start
	CScrollDialog::m_nHscrollPos = 0;
	CScrollDialog::m_nVscrollPos = 0;
// wooil insert - end
	CScrollDialog::GetClientRect(&rect);
	rect.top = 10;
	rect.left = 10;
	rect.right = 310;
	rect.bottom = 30;

//	rect(CPoint(10, 10), CSize(300, 20)); 
	CScrollDialog::InitRect(rect);
 
	// Ʈ  Ե  ʵ带 üũ ư ߰
	m_arButtons.SetSize(m_pListCtrl->GetColumnStateCount());
//	for( int i = 0 ; i < m_pListCtrl->GetColumnStateCount(); i++) {
	for( int i = 0 ; i < 8; i++) {
		// Retrieve column-title
		LVCOLUMN lvc = {0};
		lvc.mask = LVCF_TEXT;
		TCHAR sColText[256];
		lvc.pszText = sColText; 
		lvc.cchTextMax = sizeof(sColText)-1;
		VERIFY( m_pListCtrl->GetColumn(i, &lvc) );

		if (m_arButtons[i].Create(lvc.pszText, WS_VISIBLE | WS_CHILD | WS_TABSTOP | BS_AUTOCHECKBOX | BS_NOTIFY, rect, this, i + 100) == FALSE) {
			ASSERT(FALSE);
		}
		m_arButtons[i].ModifyStyleEx(WS_EX_NOPARENTNOTIFY, 0);
		m_arButtons[i].SetCheck(m_pListCtrl->IsColumnVisible(i) ? TRUE : FALSE);
		rect.OffsetRect(0, 25);
	}

	rect.top = 0;
	rect.left = 0;
	rect.right += 10;
	rect.bottom += 10;

	MoveWindow(&rect, FALSE);
	CenterWindow(AfxGetMainWnd());

	return TRUE;  // return TRUE unless you set the focus to a control
	// EXCEPTION: OCX Property Pages should return FALSE
}

void CListColumnPickerDlg::OnDestroy()
{
	CDialogEx::OnDestroy();

	m_arButtons.RemoveAll();
}

BOOL CListColumnPickerDlg::OnCommand(WPARAM wParam, LPARAM lParam)
{
	// ư ŬǾ 
	if (HIWORD(wParam) == BN_CLICKED) {
		UINT nID = LOWORD(wParam);
		int nCount = m_arButtons.GetCount();
		for (int i = 0; i < nCount; i++) {
			if (nID == m_arButtons[i].GetDlgCtrlID()) {
				// ư üũǾ  show, ׷  hide 
				m_pListCtrl->ShowColumn(i, !m_pListCtrl->IsColumnVisible(i));
				break;
			}
		}
	}

	return CDialogEx::OnCommand(wParam, lParam);
}

void CListColumnPickerDlg::OnOK()
{
	CDialogEx::OnOK();
}

void CListColumnPickerDlg::OnCancel()
{
	CDialogEx::OnCancel();
}

BOOL CListColumnPickerDlg::OnNotify(WPARAM wParam, LPARAM lParam, LRESULT* pResult)
{
	return CDialogEx::OnNotify(wParam, lParam, pResult);
}

void CListColumnPickerDlg::SetupScrollbars()
{
	CRect tempRect;				
	GetClientRect(&tempRect);	//  ۾  ũ Ի.

	WINDOWPLACEMENT wp;			//     մ .
	GetWindowPlacement(&wp);	//   .
//	BOOL bMaximized = (wp.showCmd == SW_MAXIMIZE);	// ̾ α ִ ũ .

	// Calculate how many scrolling increments for the client area
	m_nHorzInc = (m_rcOrg.Width() - tempRect.Width()) / 8;
	m_nVertInc = (m_rcOrg.Height() - tempRect.Height()) / 8;

	// Set the vertical and horizontal scrolling info
	m_nHscrollMax = max(0, m_nHorzInc);
	m_nHscrollPos = min (m_nHscrollPos, m_nHscrollMax);
	SetScrollRange(SB_HORZ, 0, m_nHscrollMax, FALSE);
	SetScrollPos(SB_HORZ, m_nHscrollPos, TRUE);
	m_nVscrollMax = max(0, m_nVertInc);
	m_nVscrollPos = min(m_nVscrollPos, m_nVscrollMax);
	SetScrollRange(SB_VERT, 0, m_nVscrollMax, FALSE);
	SetScrollPos(SB_VERT, m_nVscrollPos, TRUE);
}
