#pragma once

// CScrollDialog

#include "DialogBase.h"

// / ũ ϴ ̾α
class CScrollDialog : public CDialogBase
{
	DECLARE_DYNAMIC(CScrollDialog)

public:
	CScrollDialog(UINT ID, CWnd* pParent = NULL);
	virtual ~CScrollDialog();

protected:
	CRect	m_rcOrg;
	int		m_nHscrollPos, m_nVscrollPos;
	int		m_nHscrollMax, m_nVscrollMax;
	int		m_nHorzInc, m_nVertInc;

protected:
	void InitRect(CRect rect);
	void ResetScrollbars();
	void SetupScrollbars();

protected:
	virtual BOOL OnInitDialog();
	afx_msg void OnSize(UINT nType, int cx, int cy);
	afx_msg void OnHScroll(UINT nSBCode, UINT nPos, CScrollBar* pScrollBar);
	afx_msg void OnVScroll(UINT nSBCode, UINT nPos, CScrollBar* pScrollBar);
	afx_msg BOOL OnMouseWheel(UINT nFlags, short zDelta, CPoint pt);
	DECLARE_MESSAGE_MAP()
};


